import javax.swing.*;
import de.uniulm.sai.TableLayout;
import static de.uniulm.sai.TableLayout.AlignX.*;
import static de.uniulm.sai.TableLayout.AlignY.*;

/**
* TableLayoutDemo - A demo GUI using TableLayout
* Copyright (C) 2005	Johannes Mayer
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* @author  Johannes Mayer
* @version 0.9, 2005-08-01
*/
public class TableLayoutDemo {
    public static void main(String[] args) {
	JFrame f = new JFrame();
	f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	// TableLayout with 2 columns
	TableLayout t = new TableLayout(2);

	// settings for all cells
	t.setAlignX(FILLX);
	t.setAlignY(FILLY);
	t.setInsets(5, 5, 5, 5);

	// stretches for columns ...
	t.setColumnStretch(1, 1.0);
	// ... and rows
	t.setRowStretch(0, 0.5);
	t.setRowStretch(2, 1.0);
	t.setRowStretch(3, 1.0);

	// settings for row 2
	t.setRowAlign(2, TOP);

	// constraints objects are immutable; therefore
	// one is enough
	TableLayout.Constraints c = new TableLayout.Constraints();

	JPanel p = new JPanel();
	f.setContentPane(p);

	p.setLayout(t);

	p.add(new JButton("Button 1"));
	p.add(new JButton("Button 2"), c.alignX(LEFT).alignY(BOTTOM));
	p.add(new JButton("Button 3"));
	p.add(new JTextField());
	p.add(new JButton("Button 5"), c.size(2, 1)); // width 2 and height 1

	JPanel dummy = new JPanel();
	dummy.setBackground(java.awt.Color.blue);
	dummy.setMinimumSize(new java.awt.Dimension(0, 0));
	dummy.setPreferredSize(new java.awt.Dimension(0, 0));

	p.add(dummy);

	f.pack();
	f.setVisible(true);
    }
}
